import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _WeakMap from 'babel-runtime/core-js/weak-map';
import { cloneDeep } from 'lodash';

var privateModel = new _WeakMap();

var FormItemModelPublic = function FormItemModelPublic(model) {
  _classCallCheck(this, FormItemModelPublic);

  _initialiseProps.call(this);

  privateModel.set(this, model);
  this.id = cloneDeep(model.id);
  this.name = cloneDeep(model.name);
};

var _initialiseProps = function _initialiseProps() {
  var _this = this;

  this.reset = function () {
    var model = privateModel.get(_this);
    return model.reset();
  };

  this.reload = function () {
    var model = privateModel.get(_this);
    return model.reload();
  };

  this.init = function () {
    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var makeDirty = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    var model = privateModel.get(_this);
    return model.init(data, makeDirty);
  };

  this.makeDirty = function () {
    var model = privateModel.get(_this);
    return model.makeDirty();
  };

  this.data = function () {
    var model = privateModel.get(_this);
    return model.data();
  };

  this.values = function () {
    var model = privateModel.get(_this);
    return model.values();
  };

  this.isValid = function () {
    var model = privateModel.get(_this);
    return model.isValid();
  };

  this.isTouched = function () {
    var model = privateModel.get(_this);
    return model.isTouched();
  };

  this.errors = function () {
    var model = privateModel.get(_this);
    return cloneDeep(model.getErrors());
  };

  this.forms = function () {
    var model = privateModel.get(_this);
    return model.forms.getPublic();
  };

  this.fields = function () {
    var model = privateModel.get(_this);
    return model.fields.getPublic();
  };
};

export default FormItemModelPublic;