'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _lodash = require('lodash');

var _FieldModelPublic = require('./public/FieldModelPublic');

var _FieldModelPublic2 = _interopRequireDefault(_FieldModelPublic);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FieldModel = function () {
  function FieldModel(_ref) {
    var _this = this;

    var component = _ref.component,
        name = _ref.name,
        value = _ref.value,
        validator = _ref.validator,
        reload = _ref.reload,
        excluded = _ref.excluded;
    (0, _classCallCheck3.default)(this, FieldModel);

    this.getPublic = function () {
      return _this.__getPublic__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.setValidator = function () {
      return _this.__setValidator__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.setValue = function () {
      return _this.__setValue__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.setFocus = function () {
      return _this.__setFocus__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.setTouched = function () {
      return _this.__setTouched__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.setDirty = function () {
      return _this.__setDirty__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.validate = function () {
      return _this.__validate__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.setFormErrors = function () {
      return _this.__setFormErrors__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.setSubmissionErrors = function () {
      return _this.__setSubmissionErrors__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.reload = function () {
      return _this.__reload__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.reset = function () {
      return _this.__reset__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.makeDirty = function () {
      return _this.__makeDirty__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.makeSubmitted = function () {
      return _this.__makeSubmitted__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isValid = function () {
      return _this.__isValid__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isExcluded = function () {
      return _this.__isExcluded__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.getErrors = function () {
      return _this.__getErrors__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    if (!name) {
      throw new Error('Name is required');
    }
    this.component = component;
    this.name = name;
    this.excluded = !!excluded;
    this.initialValue = value;
    this.handleReload = reload || function () {};
    this.setValidator(validator);
    this.reset();
    this.submissionErrors = [];
    this.public = new _FieldModelPublic2.default(this);
  }

  FieldModel.prototype.__getErrors__REACT_HOT_LOADER__ = function __getErrors__REACT_HOT_LOADER__() {
    return this.__getErrors__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__isExcluded__REACT_HOT_LOADER__ = function __isExcluded__REACT_HOT_LOADER__() {
    return this.__isExcluded__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__isValid__REACT_HOT_LOADER__ = function __isValid__REACT_HOT_LOADER__() {
    return this.__isValid__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__makeSubmitted__REACT_HOT_LOADER__ = function __makeSubmitted__REACT_HOT_LOADER__() {
    return this.__makeSubmitted__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__makeDirty__REACT_HOT_LOADER__ = function __makeDirty__REACT_HOT_LOADER__() {
    return this.__makeDirty__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__reset__REACT_HOT_LOADER__ = function __reset__REACT_HOT_LOADER__() {
    return this.__reset__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__reload__REACT_HOT_LOADER__ = function __reload__REACT_HOT_LOADER__() {
    return this.__reload__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__setSubmissionErrors__REACT_HOT_LOADER__ = function __setSubmissionErrors__REACT_HOT_LOADER__() {
    return this.__setSubmissionErrors__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__setFormErrors__REACT_HOT_LOADER__ = function __setFormErrors__REACT_HOT_LOADER__() {
    return this.__setFormErrors__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__validate__REACT_HOT_LOADER__ = function __validate__REACT_HOT_LOADER__() {
    return this.__validate__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__setDirty__REACT_HOT_LOADER__ = function __setDirty__REACT_HOT_LOADER__() {
    return this.__setDirty__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__setTouched__REACT_HOT_LOADER__ = function __setTouched__REACT_HOT_LOADER__() {
    return this.__setTouched__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__setFocus__REACT_HOT_LOADER__ = function __setFocus__REACT_HOT_LOADER__() {
    return this.__setFocus__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__setValue__REACT_HOT_LOADER__ = function __setValue__REACT_HOT_LOADER__() {
    return this.__setValue__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__setValidator__REACT_HOT_LOADER__ = function __setValidator__REACT_HOT_LOADER__() {
    return this.__setValidator__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__getPublic__REACT_HOT_LOADER__ = function __getPublic__REACT_HOT_LOADER__() {
    return this.__getPublic__REACT_HOT_LOADER__.apply(this, arguments);
  };

  FieldModel.prototype.__getPublic__REACT_HOT_LOADER__ = function __getPublic__REACT_HOT_LOADER__() {
    return this.public;
  };

  FieldModel.prototype.__setValidator__REACT_HOT_LOADER__ = function __setValidator__REACT_HOT_LOADER__(validator) {
    this.validator = validator || function () {
      return [];
    };
  };

  FieldModel.prototype.__setValue__REACT_HOT_LOADER__ = function __setValue__REACT_HOT_LOADER__(value) {
    this.value = value;
  };

  FieldModel.prototype.__setFocus__REACT_HOT_LOADER__ = function __setFocus__REACT_HOT_LOADER__(focused) {
    this.focused = focused;
  };

  FieldModel.prototype.__setTouched__REACT_HOT_LOADER__ = function __setTouched__REACT_HOT_LOADER__(touched) {
    this.touched = touched;
  };

  FieldModel.prototype.__setDirty__REACT_HOT_LOADER__ = function __setDirty__REACT_HOT_LOADER__(dirty) {
    this.dirty = dirty;
  };

  FieldModel.prototype.__validate__REACT_HOT_LOADER__ = function __validate__REACT_HOT_LOADER__() {
    this.errors = [];
    this.errors = this.validator(this.name, this.value) || [];
  };

  FieldModel.prototype.__setFormErrors__REACT_HOT_LOADER__ = function __setFormErrors__REACT_HOT_LOADER__(errors) {
    this.formErrors = [];
    if (Array.isArray(errors)) {
      this.formErrors = errors;
    } else if (errors) {
      this.formErrors = [errors];
    }
  };

  FieldModel.prototype.__setSubmissionErrors__REACT_HOT_LOADER__ = function __setSubmissionErrors__REACT_HOT_LOADER__(errors) {
    this.submissionErrors = [];
    if (Array.isArray(errors)) {
      this.submissionErrors = errors;
    } else if (errors) {
      this.submissionErrors = [errors];
    }
  };

  FieldModel.prototype.__reload__REACT_HOT_LOADER__ = function __reload__REACT_HOT_LOADER__() {
    this.handleReload();
  };

  FieldModel.prototype.__reset__REACT_HOT_LOADER__ = function __reset__REACT_HOT_LOADER__() {
    this.setValue((0, _lodash.cloneDeep)(this.initialValue));
    this.focused = false;
    this.touched = false;
    this.dirty = false;
    this.submitted = false;
    this.changedAfterSubmit = false;
    this.errors = [];
    this.formErrors = [];
  };

  FieldModel.prototype.__makeDirty__REACT_HOT_LOADER__ = function __makeDirty__REACT_HOT_LOADER__() {
    this.touched = true;
    this.dirty = true;
  };

  FieldModel.prototype.__makeSubmitted__REACT_HOT_LOADER__ = function __makeSubmitted__REACT_HOT_LOADER__() {
    this.submitted = true;
    this.changedAfterSubmit = false;
  };

  FieldModel.prototype.__isValid__REACT_HOT_LOADER__ = function __isValid__REACT_HOT_LOADER__() {
    var isValid = !this.errors.length && !this.formErrors.length;
    if (this.submitted && !this.changedAfterSubmit) {
      return isValid && !this.submissionErrors.length;
    }
    return isValid;
  };

  FieldModel.prototype.__isExcluded__REACT_HOT_LOADER__ = function __isExcluded__REACT_HOT_LOADER__() {
    return this.excluded;
  };

  FieldModel.prototype.__getErrors__REACT_HOT_LOADER__ = function __getErrors__REACT_HOT_LOADER__() {
    var errors = [].concat(this.errors, this.formErrors);
    if (this.submitted && !this.changedAfterSubmit) {
      errors = [].concat(errors, this.submissionErrors);
    }
    return errors;
  };

  return FieldModel;
}();

var _default = FieldModel;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FieldModel, 'FieldModel', 'E:/Projects/React/git/vb-react-form/src/Forms/Form/FieldModel.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'E:/Projects/React/git/vb-react-form/src/Forms/Form/FieldModel.js');
}();

;